% Fuzzy system
% Refer Problem 12.13
clc; close all; clear all
%Create new FIS  with file name "FLCdemo.fis"
sys=newfis('FLCdemo')
%Add input variable x to FIS
sys=addvar(sys,'input','x',[2 9]);
%Add membership functions
sys=addmf(sys,'input',1,'A1','trimf',[2 5 8]);
sys=addmf(sys,'input',1,'A2','trimf',[3 6 9]);
%Add input variable y to FIS
sys=addvar(sys,'input','y',[4 11]);
%Add membership functions
sys=addmf(sys,'input',2,'B1','trimf',[5 8 11]);
sys=addmf(sys,'input',2,'B2','trimf',[4 7 10]);
%Add output variable z to FIS
sys=addvar(sys,'output','z',[1 9]);
%Add membership functions
sys=addmf(sys,'output',1,'C1','trimf',[1 4 7]);
sys=addmf(sys,'output',1,'C2','trimf',[3 6 9]);
%Add rules to FIS
rule=[1 1 1 1 1;2 2 2 1 1];
sys=addrule(sys,rule);
%Plot FIS I/O diagram
figure(1);
plotfis(sys);
% Perform fuzzy inference calculation (x=4;y=8)
z=evalfis([4 8],sys)
% The FIS structure for this problem has been created in FIS editor and
% saved as FuzzyPB14.fis
% Open the file FuzzyPB14 in FIS editor and export to workspace 
% (menu driven from toolbar)
% Open SimulinkFigPB14 and execute