% Create 'objprocessPB16a.m'
function [J]=objprocessPB16a(x)


global alpha beta y0 T F g sys yref simtim

% Define gain constants
GE=x(1); GV=x(2); GU=x(3);
y(1)=y0; u(1)=0;
for k=1:(simtim-1)
    e(k)=yref(k)-y(k);
    if(k==1)
        v(k)=0;
    else
        v(k)=(e(k)-e(k-1))/T;
    end
    ee(k)=e(k)*GE;
    vv(k)=v(k)*GV;
    % If any input to the FLC is not in the range defined for it,
    % then the average of the output range is taken as FLC output
    if(ee(k)>=-1 & ee(k)<=1 & vv(k)>=-1 & vv(k)<=1)
        delu(k)=evalfis([vv(k) ee(k)],sys)*GU;
    else
        delu(k)=0; 
    end
    u(k+1)=u(k)+delu(k);
    if(u(k+1)>5)
        u(k+1)=5;
    elseif(u(k+1)<0)
        u(k+1)=0;
    end
    y(k+1)=F*y(k)+(g*u(k+1)/(1+exp(0.5*y(k)-40)))+(1-F)*y0;
end
J=0;
for i=1:(simtim-1)
    J=J+abs(e(i));
end
J=1000/(1+J);

   