% Create 'objprocessPB16b.m'
function [J]=objprocessPB16b(x)


% x is a sequence of bits 

global N nbit minmax itr

% Converting binary to decimal(required by the objective function
% expression)
b1=0;
bn=0;
for j=1:N
    sum1=0;
    n=nbit(j);
    if (j==1)
        b1=1;
    else
        b1=b1+nbit(j-1);
    end
    bn=bn+nbit(j);
    % Calculate the decimal value:
    for k=b1:bn
        n=n-1;
        sum1=sum1+x(k)*(2^n);
    end
    var(j)=sum1;
end

% Scaling decimal value between min and max value of each variable

for j=1:N
    param(j)=minmax(j,1)...
        +(minmax(j,2)-minmax(j,1))/...
        (2^nbit(j)-1)*var(j);
end

x=param;

global alpha beta y0 T F g sys yref simtim

% Define gain constants
GE=x(1); GV=x(2); GU=x(3);
y(1)=y0; u(1)=0;
for k=1:(simtim-1)
    e(k)=yref(k)-y(k);
    if(k==1)
        v(k)=0;
    else
        v(k)=(e(k)-e(k-1))/T;
    end
    ee(k)=e(k)*GE;
    vv(k)=v(k)*GV;
    % If any input to the FLC is not in the range defined for it,
    % then the average of the output range is taken as FLC output
    if(ee(k)>=-1 & ee(k)<=1 & vv(k)>=-1 & vv(k)<=1)
        delu(k)=evalfis([vv(k) ee(k)],sys)*GU;
    else
        delu(k)=0; 
    end
    u(k+1)=u(k)+delu(k);
    if(u(k+1)>5)
        u(k+1)=5;
    elseif(u(k+1)<0)
        u(k+1)=0;
    end
    y(k+1)=F*y(k)+(g*u(k+1)/(1+exp(0.5*y(k)-40)))+(1-F)*y0;
end
J=0;
for i=1:(simtim-1)
    J=J+abs(e(i));
end

   