% NN servo control
clc; clear all; close all;
% Plant model 
K1=0.34366;
K2=-0.1534069;
K3=-2.286928e-3;
K4=3.5193358e-4;
K5=0.2280595;
K6=-0.105184;
%Sampling time
T=0.1;
% Generation of training data
w(1)=0;
w(2)=0;
for k=1:98
    va(k+1)=(rand-0.5)*200;
    w(k+2)=K1*w(k+1)+K2*w(k)+sign(w(k+1))*...
    (K3*w(k+1)*w(k+1)+K4*w(k)*w(k))+K5*va(k+1)+K6;
end
NNinput=[w(3:100);w(2:99);w(1:98)];
NNoutput=[va(2:99)];
% Preprocessing of training data
NNinput=NNinput/30;
NNoutput=NNoutput/100;
% Creation & training of NN
net=newff(minmax(NNinput),[4 1],{'tansig','purelin'},'traingdx');
net.trainparam.epochs=500;
net.trainparam.goal=0.005;
[net tr]=train(net,NNinput,NNoutput);
% Weights and biases of trained NN
w1=net.IW{1,1}
b1=net.b{1}
w2=net.LW{2,1}
b2=net.b{2}
% Testing the trained NN
kmax=floor(20/T);
for k=1:kmax
    va(k)=50*sin(2*pi*k*T/7)+45*sin(2*pi*k*T/3);
end
wt(1)=0;
wt(2)=0;
for k=1:(kmax-1)
    wt(k+2)=K1*wt(k+1)+K2*wt(k)+sign(wt(k+1))*...
    (K3*wt(k+1)*wt(k+1)+K4*wt(k)*wt(k))+K5*va(k+1)+K6;
end
va_cap(1)=0;
for k=1:(kmax-1)
    NNinput=[wt(k+2);wt(k+1);wt(k)]/30;
    va_cap(k+1)=sim(net,NNinput)*100;
end
figure(1)
plot(1:kmax,va_cap,'r',1:kmax,va)
% Reference trajectory
for k=1:kmax
    wr(k)=10*sin(2*pi*k*T/4)+16*sin(2*pi*k*T/7);
end
% Simulation
% Command-line simulation
w_sim(1)=0;
w_sim(2)=0;
for k=1:kmax-2
    inp=[wr(k+2);w_sim(k+1);w_sim(k)]/30;
    va_sim(k+1)=sim(net,inp)*100;
    w_sim(k+2)=K1*w_sim(k+1)+K2*w_sim(k)+sign(w_sim(k+1))*...
    (K3*w_sim(k+1)*w_sim(k+1)+K4*w_sim(k)*w_sim(k))+K5*va_sim(k+1)+K6;
end
figure(2)
plot(1:kmax,wr,1:kmax,w_sim,'r');
% The command gensim(net,T) results in a Simulink screen containing
% the NN object net. We may build the feedback control system on this
% screen to simulate its performance
% Open SimulinkFigPB9; before creating this Simulink file, the command 
% gensim(net,T) was executed in MATLAB command window.